Index: /trunk/src/gnu/lib/libbfd/arch/mipseb/bfd.h
===================================================================
--- /trunk/src/gnu/lib/libbfd/arch/mipseb/bfd.h	(revision 151)
+++ /trunk/src/gnu/lib/libbfd/arch/mipseb/bfd.h	(revision 152)
@@ -1611,4 +1611,5 @@
 #define bfd_mach_mips5                 5
 #define bfd_mach_mips_sb1              12310201 /* octal 'SB', 01 */
+#define bfd_mach_mips_xlr              887682   /* decimal 'XLR'  */
 #define bfd_mach_mipsisa32             32
 #define bfd_mach_mipsisa32r2           33
Index: /trunk/src/gnu/lib/libbfd/arch/mipsel/bfd.h
===================================================================
--- /trunk/src/gnu/lib/libbfd/arch/mipsel/bfd.h	(revision 151)
+++ /trunk/src/gnu/lib/libbfd/arch/mipsel/bfd.h	(revision 152)
@@ -1611,4 +1611,5 @@
 #define bfd_mach_mips5                 5
 #define bfd_mach_mips_sb1              12310201 /* octal 'SB', 01 */
+#define bfd_mach_mips_xlr              887682   /* decimal 'XLR'  */
 #define bfd_mach_mipsisa32             32
 #define bfd_mach_mipsisa32r2           33
Index: /trunk/src/gnu/lib/libbfd/arch/powerpc/bfd.h
===================================================================
--- /trunk/src/gnu/lib/libbfd/arch/powerpc/bfd.h	(revision 151)
+++ /trunk/src/gnu/lib/libbfd/arch/powerpc/bfd.h	(revision 152)
@@ -1611,4 +1611,5 @@
 #define bfd_mach_mips5                 5
 #define bfd_mach_mips_sb1              12310201 /* octal 'SB', 01 */
+#define bfd_mach_mips_xlr              887682   /* decimal 'XLR'  */
 #define bfd_mach_mipsisa32             32
 #define bfd_mach_mipsisa32r2           33
Index: /trunk/src/gnu/lib/libbfd/arch/powerpc64/bfd.h
===================================================================
--- /trunk/src/gnu/lib/libbfd/arch/powerpc64/bfd.h	(revision 151)
+++ /trunk/src/gnu/lib/libbfd/arch/powerpc64/bfd.h	(revision 152)
@@ -1612,4 +1612,5 @@
 #define bfd_mach_mips5                 5
 #define bfd_mach_mips_sb1              12310201 /* octal 'SB', 01 */
+#define bfd_mach_mips_xlr              887682   /* decimal 'XLR'  */
 #define bfd_mach_mipsisa32             32
 #define bfd_mach_mipsisa32r2           33
Index: /trunk/src/gnu/lib/libbfd/arch/sh3eb/bfd.h
===================================================================
--- /trunk/src/gnu/lib/libbfd/arch/sh3eb/bfd.h	(revision 151)
+++ /trunk/src/gnu/lib/libbfd/arch/sh3eb/bfd.h	(revision 152)
@@ -1612,4 +1612,5 @@
 #define bfd_mach_mips5                 5
 #define bfd_mach_mips_sb1              12310201 /* octal 'SB', 01 */
+#define bfd_mach_mips_xlr              887682   /* decimal 'XLR'  */
 #define bfd_mach_mipsisa32             32
 #define bfd_mach_mipsisa32r2           33
Index: /trunk/src/gnu/lib/libbfd/arch/sh3el/bfd.h
===================================================================
--- /trunk/src/gnu/lib/libbfd/arch/sh3el/bfd.h	(revision 151)
+++ /trunk/src/gnu/lib/libbfd/arch/sh3el/bfd.h	(revision 152)
@@ -1612,4 +1612,5 @@
 #define bfd_mach_mips5                 5
 #define bfd_mach_mips_sb1              12310201 /* octal 'SB', 01 */
+#define bfd_mach_mips_xlr              887682   /* decimal 'XLR'  */
 #define bfd_mach_mipsisa32             32
 #define bfd_mach_mipsisa32r2           33
Index: /trunk/src/gnu/lib/libbfd/arch/sparc/bfd.h
===================================================================
--- /trunk/src/gnu/lib/libbfd/arch/sparc/bfd.h	(revision 151)
+++ /trunk/src/gnu/lib/libbfd/arch/sparc/bfd.h	(revision 152)
@@ -1611,4 +1611,5 @@
 #define bfd_mach_mips5                 5
 #define bfd_mach_mips_sb1              12310201 /* octal 'SB', 01 */
+#define bfd_mach_mips_xlr              887682   /* decimal 'XLR'  */
 #define bfd_mach_mipsisa32             32
 #define bfd_mach_mipsisa32r2           33
Index: /trunk/src/gnu/lib/libbfd/arch/sparc64/bfd.h
===================================================================
--- /trunk/src/gnu/lib/libbfd/arch/sparc64/bfd.h	(revision 151)
+++ /trunk/src/gnu/lib/libbfd/arch/sparc64/bfd.h	(revision 152)
@@ -1611,4 +1611,5 @@
 #define bfd_mach_mips5                 5
 #define bfd_mach_mips_sb1              12310201 /* octal 'SB', 01 */
+#define bfd_mach_mips_xlr              887682   /* decimal 'XLR'  */
 #define bfd_mach_mipsisa32             32
 #define bfd_mach_mipsisa32r2           33
Index: /trunk/src/gnu/lib/libbfd/arch/vax/bfd.h
===================================================================
--- /trunk/src/gnu/lib/libbfd/arch/vax/bfd.h	(revision 151)
+++ /trunk/src/gnu/lib/libbfd/arch/vax/bfd.h	(revision 152)
@@ -1611,4 +1611,5 @@
 #define bfd_mach_mips5                 5
 #define bfd_mach_mips_sb1              12310201 /* octal 'SB', 01 */
+#define bfd_mach_mips_xlr              887682   /* decimal 'XLR'  */
 #define bfd_mach_mipsisa32             32
 #define bfd_mach_mipsisa32r2           33
Index: /trunk/src/gnu/lib/libbfd/arch/x86_64/bfd.h
===================================================================
--- /trunk/src/gnu/lib/libbfd/arch/x86_64/bfd.h	(revision 151)
+++ /trunk/src/gnu/lib/libbfd/arch/x86_64/bfd.h	(revision 152)
@@ -1611,4 +1611,5 @@
 #define bfd_mach_mips5                 5
 #define bfd_mach_mips_sb1              12310201 /* octal 'SB', 01 */
+#define bfd_mach_mips_xlr              887682   /* decimal 'XLR'  */
 #define bfd_mach_mipsisa32             32
 #define bfd_mach_mipsisa32r2           33
Index: /trunk/src/gnu/usr.bin/gdb6/arch/mips64eb/version.c
===================================================================
--- /trunk/src/gnu/usr.bin/gdb6/arch/mips64eb/version.c	(revision 151)
+++ /trunk/src/gnu/usr.bin/gdb6/arch/mips64eb/version.c	(revision 152)
@@ -5,4 +5,4 @@
 #include "version.h"
 const char version[] = "6.5";
-const char host_name[] = "mipseb--netbsd";
-const char target_name[] = "mipseb--netbsd";
+const char host_name[] = "mips64--netbsd";
+const char target_name[] = "mips64--netbsd";
Index: /trunk/src/gnu/usr.bin/gdb6/arch/mips64el/version.c
===================================================================
--- /trunk/src/gnu/usr.bin/gdb6/arch/mips64el/version.c	(revision 151)
+++ /trunk/src/gnu/usr.bin/gdb6/arch/mips64el/version.c	(revision 152)
@@ -5,4 +5,4 @@
 #include "version.h"
 const char version[] = "6.5";
-const char host_name[] = "mipsel--netbsd";
-const char target_name[] = "mipsel--netbsd";
+const char host_name[] = "mips64el--netbsd";
+const char target_name[] = "mips64el--netbsd";
Index: /trunk/src/include/heimdal/protos.h
===================================================================
--- /trunk/src/include/heimdal/protos.h	(revision 151)
+++ /trunk/src/include/heimdal/protos.h	(revision 152)
@@ -35,5 +35,5 @@
  * Add here functions that don't have a prototype on your system.
  *
- * $Id: protos.h,v 1.1 2000/06/16 19:18:30 thorpej Exp $
+ * $Id: protos.h,v 1.1.1.1 2000/06/16 19:18:30 thorpej Exp $
  */
 
Index: /trunk/src/include/math.h
===================================================================
--- /trunk/src/include/math.h	(revision 151)
+++ /trunk/src/include/math.h	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: math.h,v 1.47.16.1 2010/04/21 05:26:00 matt Exp $	*/
+/*	$NetBSD: math.h,v 1.47.16.2 2011/04/29 07:40:46 matt Exp $	*/
 
 /*
@@ -99,6 +99,10 @@
 /* 7.12#5 NAN: a quiet NaN, if supported */
 #ifdef __HAVE_NANF
+#if __GNUC_PREREQ__(3,3)
+#define NAN     __builtin_nanf("")
+#else
 extern const union __float_u __nanf;
 #define	NAN		__nanf.__val
+#endif
 #endif /* __HAVE_NANF */
 
Index: /trunk/src/lib/csu/mips/crt0.c
===================================================================
--- /trunk/src/lib/csu/mips/crt0.c	(revision 151)
+++ /trunk/src/lib/csu/mips/crt0.c	(revision 152)
@@ -1,3 +1,3 @@
-/* $NetBSD: crt0.c,v 1.19.32.1 2009/08/30 09:59:26 matt Exp $ */
+/* $NetBSD: crt0.c,v 1.19.32.2 2011/02/15 18:07:30 matt Exp $ */
 
 /*
@@ -119,5 +119,5 @@
 
 
-	argc = *(int *)ksp;
+	argc = *(long *)ksp;
 	argv = ksp + 1;
 	environ = ksp + 2 + argc;	/* 2: argc + NULL ending argv */
@@ -164,5 +164,5 @@
  */
 #if defined(LIBC_SCCS) && !defined(lint)
-__RCSID("$NetBSD: crt0.c,v 1.19.32.1 2009/08/30 09:59:26 matt Exp $");
+__RCSID("$NetBSD: crt0.c,v 1.19.32.2 2011/02/15 18:07:30 matt Exp $");
 #endif /* LIBC_SCCS and not lint */
 
Index: /trunk/src/lib/libc/arch/mips/Makefile.inc
===================================================================
--- /trunk/src/lib/libc/arch/mips/Makefile.inc	(revision 151)
+++ /trunk/src/lib/libc/arch/mips/Makefile.inc	(revision 152)
@@ -1,3 +1,5 @@
-#	$NetBSD: Makefile.inc,v 1.8.34.2 2009/08/27 16:51:27 matt Exp $
+#	$NetBSD: Makefile.inc,v 1.8.34.3 2011/04/29 07:48:33 matt Exp $
+
+.include <bsd.own.mk>
 
 SRCS+=	__sigaction14_sigtramp.c __sigtramp2.S
@@ -9,3 +11,4 @@
 .include <softfloat/Makefile.inc>
 CPPFLAGS+= -DSOFTFLOAT_NEED_FIXUNS
+CPPFLAGS+= -DSOFTFLOAT
 .endif
Index: /trunk/src/lib/libc/arch/mips/gdtoa/Makefile.inc
===================================================================
--- /trunk/src/lib/libc/arch/mips/gdtoa/Makefile.inc	(revision 151)
+++ /trunk/src/lib/libc/arch/mips/gdtoa/Makefile.inc	(revision 152)
@@ -1,3 +1,9 @@
-#	$NetBSD: Makefile.inc,v 1.1 2006/03/15 17:35:18 kleink Exp $
+#	$NetBSD: Makefile.inc,v 1.1.34.1 2011/04/29 07:48:33 matt Exp $
 
 SRCS+=	strtof.c
+.if (${MACHINE_ARCH} == "mips64eb" || ${MACHINE_ARCH} == "mips64el")
+.if !defined(CPUFLAGS) || empty(CPUFLAGS:M-mabi=32)
+SRCS+=	strtold_pQ.c
+SRCS+=	strtopQ.c
+.endif
+.endif
Index: /trunk/src/lib/libc/arch/mips/gdtoa/gd_qnan.h
===================================================================
--- /trunk/src/lib/libc/arch/mips/gdtoa/gd_qnan.h	(revision 151)
+++ /trunk/src/lib/libc/arch/mips/gdtoa/gd_qnan.h	(revision 152)
@@ -1,3 +1,3 @@
-/* $NetBSD: gd_qnan.h,v 1.1 2006/01/25 15:33:28 kleink Exp $ */
+/* $NetBSD: gd_qnan.h,v 1.1.34.1 2011/04/29 07:48:34 matt Exp $ */
 
 #include <machine/endian.h>
@@ -7,6 +7,14 @@
 #define d_QNAN0 0x7ff40000
 #define d_QNAN1 0x0
+#define ld_QNAN0 0x7fff8000
+#define ld_QNAN1 0x0
+#define ld_QNAN2 0x0
+#define ld_QNAN3 0x0
 #else
 #define d_QNAN0 0x0
 #define d_QNAN1 0x7ff40000
+#define ld_QNAN0 0x0
+#define ld_QNAN1 0x0
+#define ld_QNAN2 0x0
+#define ld_QNAN3 0x7fff8000
 #endif
Index: /trunk/src/lib/libc/arch/mips/gen/Makefile.inc
===================================================================
--- /trunk/src/lib/libc/arch/mips/gen/Makefile.inc	(revision 151)
+++ /trunk/src/lib/libc/arch/mips/gen/Makefile.inc	(revision 152)
@@ -1,3 +1,3 @@
-#	$NetBSD: Makefile.inc,v 1.28.34.2 2010/01/27 06:55:25 matt Exp $
+#	$NetBSD: Makefile.inc,v 1.28.34.3 2011/04/29 07:48:34 matt Exp $
 
 .if ${MKSOFTFLOAT} == "no"
@@ -8,10 +8,10 @@
 
 # Common ieee754 constants and functions
-SRCS+=	infinityf_ieee754.c infinity_ieee754.c infinityl_dbl_ieee754.c
-SRCS+=	fpclassifyf_ieee754.c fpclassifyd_ieee754.c
-SRCS+=	isinff_ieee754.c isinfd_ieee754.c
-SRCS+=	isnanf_ieee754.c isnand_ieee754.c
-SRCS+=	isfinitef_ieee754.c isfinited_ieee754.c
-SRCS+=	signbitf_ieee754.c signbitd_ieee754.c
+SRCS+=	infinityf_ieee754.c infinity_ieee754.c infinityl_ieee754.c
+SRCS+=	fpclassifyf_ieee754.c fpclassifyd_ieee754.c fpclassifyl_ieee754.c
+SRCS+=	isinff_ieee754.c isinfd_ieee754.c isinfl_ieee754.c
+SRCS+=	isnanf_ieee754.c isnand_ieee754.c isnanl_ieee754.c
+SRCS+=	isfinitef_ieee754.c isfinited_ieee754.c isfinitel_ieee754.c
+SRCS+=	signbitf_ieee754.c signbitd_ieee754.c signbitl_ieee754.c
 
 SRCS+=	nanf.c
@@ -33,6 +33,8 @@
 SRCS+=	cacheflush.c
 
-SRCS.mips.gen=	Lint__setjmp.c Lint_bswap16.c Lint_bswap32.c Lint_swapcontext.c
-LSRCS+=		${SRCS.mips.gen}
-DPSRCS+=	${SRCS.mips.gen}
-CLEANFILES+=	${SRCS.mips.gen}
+CPPFLAGS._lwp.c	+= -D_LIBC_SOURCE
+
+LSRCS.mips.gen=	Lint__setjmp.c Lint_bswap16.c Lint_bswap32.c Lint_swapcontext.c
+LSRCS+=		${LSRCS.mips.gen}
+DPSRCS+=	${LSRCS.mips.gen}
+CLEANFILES+=	${LSRCS.mips.gen}
Index: /trunk/src/lib/libc/arch/mips/gen/_lwp.c
===================================================================
--- /trunk/src/lib/libc/arch/mips/gen/_lwp.c	(revision 151)
+++ /trunk/src/lib/libc/arch/mips/gen/_lwp.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: _lwp.c,v 1.5 2008/04/28 20:22:56 martin Exp $	*/
+/*	$NetBSD: _lwp.c,v 1.5.14.2 2011/04/29 08:03:55 matt Exp $	*/
 
 /*
@@ -32,5 +32,5 @@
 #include <sys/cdefs.h>
 #if defined(LIBC_SCCS) && !defined(lint)
-__RCSID("$NetBSD: _lwp.c,v 1.5 2008/04/28 20:22:56 martin Exp $");
+__RCSID("$NetBSD: _lwp.c,v 1.5.14.2 2011/04/29 08:03:55 matt Exp $");
 #endif /* LIBC_SCCS and not lint */
 
@@ -41,8 +41,13 @@
 #include <stdlib.h>
 
-#define CALLFRAME_SIZ	24
+#if defined(__mips_o32) || defined(__mips_o64)
+#define CALLFRAME_SIZ	(6 * sizeof(void *))
+#else
+#define CALLFRAME_SIZ	(4 * sizeof(uint64_t))
+#endif
 
-void _lwp_makecontext(ucontext_t *u, void (*start)(void *),
-	void *arg, void *private, caddr_t stack_base, size_t stack_size)
+void
+_lwp_makecontext(ucontext_t *u, void (*start)(void *),
+	void *arg, void *tcb, caddr_t stack_base, size_t stack_size)
 {
 	caddr_t sp;
@@ -57,8 +62,11 @@
 	sp = stack_base + stack_size - CALLFRAME_SIZ;
 
-	gr[_REG_EPC] = (unsigned long) start;
-	gr[_REG_T9] = (unsigned long) start; /* required for .abicalls */
-	gr[_REG_RA] = (unsigned long) _lwp_exit;
-	gr[_REG_A0] = (unsigned long) arg;
-	gr[_REG_SP] = (unsigned long) sp;
+	gr[_REG_EPC] = (uintptr_t) start;
+	gr[_REG_T9] = (uintptr_t) start; /* required for .abicalls */
+	gr[_REG_RA] = (uintptr_t) _lwp_exit;
+	gr[_REG_A0] = (uintptr_t) arg;
+	gr[_REG_SP] = (uintptr_t) sp;
+	u->uc_mcontext._mc_tlsbase =
+	    (uintptr_t)tcb + TLS_TP_OFFSET + sizeof(struct tls_tcb);
+	u->uc_flags |= _UC_TLSBASE;
 }
Index: /trunk/src/lib/libc/arch/mips/gen/_setjmp.S
===================================================================
--- /trunk/src/lib/libc/arch/mips/gen/_setjmp.S	(revision 151)
+++ /trunk/src/lib/libc/arch/mips/gen/_setjmp.S	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: _setjmp.S,v 1.20.34.5 2010/02/03 23:46:47 matt Exp $	*/
+/*	$NetBSD: _setjmp.S,v 1.20.34.6 2011/04/29 08:01:50 matt Exp $	*/
 
 /*-
@@ -47,5 +47,5 @@
 	RCSID("from: @(#)_setjmp.s	8.1 (Berkeley) 6/4/93")
 #else
-	RCSID("$NetBSD: _setjmp.S,v 1.20.34.5 2010/02/03 23:46:47 matt Exp $")
+	RCSID("$NetBSD: _setjmp.S,v 1.20.34.6 2011/04/29 08:01:50 matt Exp $")
 #endif
 #endif /* LIBC_SCCS and not lint */
@@ -89,5 +89,4 @@
 #ifndef SOFTFLOAT_FOR_GCC
 	cfc1	v0, $31				# too bad cant check if FP used
-	INT_S	v0, _OFFSETOF_SC_FPREGS_FCSR(a0)
 #if defined(__mips_n64) || defined(__mips_n32)
 	FP_S	$f30, _OFFSETOF_SC_FPREGS_F30(a0)
@@ -110,4 +109,5 @@
 	FP_S	$f31, _OFFSETOF_SC_FPREGS_F31(a0)
 #endif
+	INT_S	v0, _OFFSETOF_SC_FPREGS_FCSR(a0)
 #endif	/* SOFTFLOAT_FOR_GCC */
 	REG_EPILOGUE
@@ -140,9 +140,11 @@
 	REG_L		gp, _OFFSETOF_SC_REGS_GP(a0)
 #endif
+#ifndef SOFTFLOAT_FOR_GCC
 	# get fpu status
+	INT_L		v0, _OFFSETOF_SC_FPREGS_FCSR(a0)
+#endif
 	REG_L		sp, _OFFSETOF_SC_REGS_SP(a0)
 	REG_L		s8, _OFFSETOF_SC_REGS_S8(a0)
 #ifndef SOFTFLOAT_FOR_GCC
-	INT_L		v0, _OFFSETOF_SC_FPREGS_FCSR(a0)
 	ctc1		v0, $31
 	/*
@@ -174,7 +176,6 @@
 
 	REG_EPILOGUE
-	move	v0, a1			# get return value in 1st arg
 	j	ra
-	nop
+	 move	v0, a1			# get return value in 1st arg
 
 botch:
@@ -184,5 +185,7 @@
 	 */
 	jal	_C_LABEL(longjmperror)
+	 nop
 	
 	PIC_TAILCALL(abort)
+	 nop
 END(_longjmp)
Index: /trunk/src/lib/libc/arch/mips/gen/longjmp.c
===================================================================
--- /trunk/src/lib/libc/arch/mips/gen/longjmp.c	(revision 151)
+++ /trunk/src/lib/libc/arch/mips/gen/longjmp.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: longjmp.c,v 1.2.14.2 2010/04/30 16:23:23 matt Exp $	*/
+/*	$NetBSD: longjmp.c,v 1.2.14.3 2011/04/29 08:01:50 matt Exp $	*/
 
 /*-
@@ -50,5 +50,5 @@
 
 	/* Ensure non-zero SP and sigcontext magic number is present */
-	if (sc->sc_regs[_R_SP] == 0 || sc->sc_regs[_R_ZERO] != 0xACEDBADE)
+	if (sc->sc_regs[_R_SP] == 0 || sc->sc_regs[_R_ZERO] != (mips_reg_t)0xACEDBADE)
 		goto err;
 
Index: /trunk/src/lib/libc/arch/mips/gen/nanf.c
===================================================================
--- /trunk/src/lib/libc/arch/mips/gen/nanf.c	(revision 151)
+++ /trunk/src/lib/libc/arch/mips/gen/nanf.c	(revision 152)
@@ -1,7 +1,7 @@
-/*	$NetBSD: nanf.c,v 1.3 2005/04/15 22:39:11 kleink Exp $	*/
+/*	$NetBSD: nanf.c,v 1.3.36.1 2011/04/29 07:40:47 matt Exp $	*/
 
 #include <sys/cdefs.h>
 #if defined(LIBC_SCCS) && !defined(lint)
-__RCSID("$NetBSD: nanf.c,v 1.3 2005/04/15 22:39:11 kleink Exp $");
+__RCSID("$NetBSD: nanf.c,v 1.3.36.1 2011/04/29 07:40:47 matt Exp $");
 #endif /* LIBC_SCCS and not lint */
 
@@ -16,2 +16,4 @@
 		{ {    0,    0, 0xa0, 0x7f } };
 #endif
+
+__warn_references(__nanf, "warning: <math.h> defines NAN incorrectly for your compiler.")
Index: /trunk/src/lib/libc/arch/mips/net/Makefile.inc
===================================================================
--- /trunk/src/lib/libc/arch/mips/net/Makefile.inc	(revision 151)
+++ /trunk/src/lib/libc/arch/mips/net/Makefile.inc	(revision 152)
@@ -1,3 +1,3 @@
-#	$NetBSD: Makefile.inc,v 1.3 2003/08/01 17:03:51 lukem Exp $
+#	$NetBSD: Makefile.inc,v 1.3.46.1 2011/04/29 08:01:51 matt Exp $
 
 # objects built from assembler sources (need lint stubs)
@@ -5,6 +5,6 @@
 SRCS+=  
 
-SRCS.mips.net=	Lint_htonl.c Lint_htons.c Lint_ntohl.c Lint_ntohs.c
-LSRCS+=		${SRCS.mips.net}
-DPSRCS+=	${SRCS.mips.net}
-CLEANFILES+=	${SRCS.mips.net}
+LSRCS.mips.net=	Lint_htonl.c Lint_htons.c Lint_ntohl.c Lint_ntohs.c
+LSRCS+=		${LSRCS.mips.net}
+DPSRCS+=	${LSRCS.mips.net}
+CLEANFILES+=	${LSRCS.mips.net}
Index: /trunk/src/lib/libc/arch/mips/softfloat/mips-gcc.h
===================================================================
--- /trunk/src/lib/libc/arch/mips/softfloat/mips-gcc.h	(revision 151)
+++ /trunk/src/lib/libc/arch/mips/softfloat/mips-gcc.h	(revision 152)
@@ -1,3 +1,3 @@
-/* $NetBSD: mips-gcc.h,v 1.1.2.1 2009/08/27 16:51:27 matt Exp $ */
+/* $NetBSD: mips-gcc.h,v 1.1.2.2 2011/04/29 07:48:34 matt Exp $ */
 
 /*
@@ -86,10 +86,15 @@
 /*
 -------------------------------------------------------------------------------
-The ARM FPA is odd in that it stores doubles high-order word first, no matter
+The MIPS FPA is odd in that it stores doubles high-order word first, no matter
 what the endianness of the CPU.  VFP is sane.
 -------------------------------------------------------------------------------
 */
 #if defined(SOFTFLOAT_FOR_GCC)
+#if defined(__MIPSEB__)
 #define FLOAT64_DEMANGLE(a)	(a)
 #define FLOAT64_MANGLE(a)	(a)
+#else
+#define FLOAT64_DEMANGLE(a)	(((a) << 32) | ((a) >> 32))
+#define FLOAT64_MANGLE(a)	FLOAT64_DEMANGLE(a)
 #endif
+#endif
Index: /trunk/src/lib/libc/arch/mips/softfloat/softfloat.h
===================================================================
--- /trunk/src/lib/libc/arch/mips/softfloat/softfloat.h	(revision 151)
+++ /trunk/src/lib/libc/arch/mips/softfloat/softfloat.h	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: softfloat.h,v 1.1.2.1 2009/08/27 16:51:27 matt Exp $	*/
+/*	softfloat.h,v 1.1.2.2 2011/04/29 07:48:34 matt Exp	*/
 
 /* This is a derivative work. */
@@ -43,5 +43,7 @@
 */
 /* #define FLOATX80 */
-/* #define FLOAT128 */
+#if defined(__mips_n32) || defined(__mips_n64)
+#define FLOAT128
+#endif
 
 #include <machine/ieeefp.h>
@@ -134,7 +136,7 @@
 floatx80 int64_to_floatx80( long long );
 #endif
+#endif
 #ifdef FLOAT128
 float128 int64_to_float128( long long );
-#endif
 #endif
 
@@ -284,5 +286,5 @@
 int float128_to_int32_round_to_zero( float128 );
 #if defined(SOFTFLOAT_FOR_GCC) && defined(SOFTFLOAT_NEED_FIXUNS)
-unsigned int float128_to_uint32_round_to_zero( float64 );
+unsigned int float128_to_uint32_round_to_zero( float128 );
 #endif
 long long float128_to_int64( float128 );
@@ -316,5 +318,6 @@
 int float128_lt_quiet( float128, float128 );
 int float128_is_signaling_nan( float128 );
-
-#endif
-
+flag float128_is_nan( float128 );
+
+#endif
+
Index: /trunk/src/lib/libc/arch/mips/string/bzero.S
===================================================================
--- /trunk/src/lib/libc/arch/mips/string/bzero.S	(revision 151)
+++ /trunk/src/lib/libc/arch/mips/string/bzero.S	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: bzero.S,v 1.8.46.2 2009/08/18 06:55:09 matt Exp $	*/
+/*	$NetBSD: bzero.S,v 1.8.46.3 2011/04/29 08:01:51 matt Exp $	*/
 
 /*-
@@ -39,5 +39,5 @@
 	RCSID("from: @(#)bzero.s	8.1 (Berkeley) 6/4/93")
 #else
-	RCSID("$NetBSD: bzero.S,v 1.8.46.2 2009/08/18 06:55:09 matt Exp $")
+	RCSID("$NetBSD: bzero.S,v 1.8.46.3 2011/04/29 08:01:51 matt Exp $")
 #endif
 #endif /* LIBC_SCCS and not lint */
@@ -72,5 +72,5 @@
 #endif
 	nor		a2, zero, a2	# complement the mask
-	REL_L		v0, -SZREG(a0)	# load the word to partially clear
+	REG_L		v0, -SZREG(a0)	# load the word to partially clear
 	and		v0, v0, a2	# clear the bytes
 	REG_S		v0, -SZREG(a0)	# store it back
Index: /trunk/src/lib/libc/arch/mips/sys/brk.S
===================================================================
--- /trunk/src/lib/libc/arch/mips/sys/brk.S	(revision 151)
+++ /trunk/src/lib/libc/arch/mips/sys/brk.S	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: brk.S,v 1.16.46.3 2009/09/05 03:04:58 matt Exp $	*/
+/*	$NetBSD: brk.S,v 1.16.46.4 2011/04/29 08:01:51 matt Exp $	*/
 
 /*-
@@ -39,5 +39,5 @@
 	RCSID("from: @(#)brk.s	8.1 (Berkeley) 6/4/93")
 #else
-	RCSID("$NetBSD: brk.S,v 1.16.46.3 2009/09/05 03:04:58 matt Exp $")
+	RCSID("$NetBSD: brk.S,v 1.16.46.4 2011/04/29 08:01:51 matt Exp $")
 #endif
 #endif /* LIBC_SCCS and not lint */
Index: /trunk/src/lib/libc/arch/mips/sys/sbrk.S
===================================================================
--- /trunk/src/lib/libc/arch/mips/sys/sbrk.S	(revision 151)
+++ /trunk/src/lib/libc/arch/mips/sys/sbrk.S	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: sbrk.S,v 1.16.34.3 2009/09/05 03:04:58 matt Exp $	*/
+/*	$NetBSD: sbrk.S,v 1.16.34.4 2011/04/29 08:01:51 matt Exp $	*/
 
 /*-
@@ -39,5 +39,5 @@
 	RCSID("from: @(#)sbrk.s	8.1 (Berkeley) 6/4/93")
 #else
-	RCSID("$NetBSD: sbrk.S,v 1.16.34.3 2009/09/05 03:04:58 matt Exp $")
+	RCSID("$NetBSD: sbrk.S,v 1.16.34.4 2011/04/29 08:01:51 matt Exp $")
 #endif
 #endif /* LIBC_SCCS and not lint */
Index: /trunk/src/lib/libc/gen/fpclassifyl_ieee754.c
===================================================================
--- /trunk/src/lib/libc/gen/fpclassifyl_ieee754.c	(revision 152)
+++ /trunk/src/lib/libc/gen/fpclassifyl_ieee754.c	(revision 152)
@@ -0,0 +1,68 @@
+/*	$NetBSD: fpclassifyl_ieee754.c,v 1.1.4.2 2011/04/29 07:48:34 matt Exp $	*/
+
+/*-
+ * Copyright (c) 2011 The NetBSD Foundation, Inc.
+ * All rights reserved.
+ *
+ * This code is derived from software contributed to The NetBSD Foundation
+ * by Matt Thomas.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
+ * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
+ * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+ * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
+ * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+ * POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <sys/cdefs.h>
+#if defined(LIBC_SCCS) && !defined(lint)
+__RCSID("$NetBSD: fpclassifyl_ieee754.c,v 1.1.4.2 2011/04/29 07:48:34 matt Exp $");
+#endif
+
+#include <machine/ieee.h>
+#include <math.h>
+
+#ifdef __HAVE_LONG_DOUBLE
+/*
+ * 7.12.3.1 fpclassify - classify real floating type
+ *          IEEE 754 compatible 128-bit extended-precision version
+ */
+int
+__fpclassifyl(long double x)
+{
+	union ieee_ext_u u;
+
+	u.extu_ld = x;
+
+	if (u.extu_ext.ext_exp == 0) {
+		if (u.extu_ext.ext_frach == 0 && u.extu_ext.ext_frachm == 0
+		    && u.extu_ext.ext_fraclm == 0 && u.extu_ext.ext_fracl == 0)
+			return FP_ZERO;
+		else
+			return FP_SUBNORMAL;
+	} else if (u.extu_ext.ext_exp == EXT_EXP_INFNAN) {
+		if (u.extu_ext.ext_frach == 0 && u.extu_ext.ext_frachm == 0
+		    && u.extu_ext.ext_fraclm == 0 && u.extu_ext.ext_fracl == 0)
+			return FP_INFINITE;
+		else
+			return FP_NAN;
+	}
+
+	return FP_NORMAL;
+}
+#endif /* __HAVE_LONG_DOUBLE */
Index: /trunk/src/lib/libc/gen/glob.c
===================================================================
--- /trunk/src/lib/libc/gen/glob.c	(revision 151)
+++ /trunk/src/lib/libc/gen/glob.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: glob.c,v 1.23 2008/05/26 13:06:38 ad Exp $	*/
+/*	$NetBSD: glob.c,v 1.23.12.1 2011/05/20 08:11:17 matt Exp $	*/
 
 /*
@@ -38,5 +38,5 @@
 static char sccsid[] = "@(#)glob.c	8.3 (Berkeley) 10/13/93";
 #else
-__RCSID("$NetBSD: glob.c,v 1.23 2008/05/26 13:06:38 ad Exp $");
+__RCSID("$NetBSD: glob.c,v 1.23.12.1 2011/05/20 08:11:17 matt Exp $");
 #endif
 #endif /* LIBC_SCCS and not lint */
@@ -88,8 +88,11 @@
 #endif
 
-#if !defined(ARG_MAX)
-#include <limits.h>
-#define	ARG_MAX	_POSIX_ARG_MAX
-#endif
+#define	GLOB_LIMIT_MALLOC	65536
+#define	GLOB_LIMIT_STAT		128
+#define	GLOB_LIMIT_READDIR	16384
+
+#define	GLOB_INDEX_MALLOC	0
+#define	GLOB_INDEX_STAT		1
+#define	GLOB_INDEX_READDIR	2
 
 /*
@@ -156,5 +159,5 @@
 static Char	*g_strchr(const Char *, int);
 static int	 g_stat(Char *, __gl_stat_t *, glob_t *);
-static int	 glob0(const Char *, glob_t *);
+static int	 glob0(const Char *, glob_t *, size_t *);
 static int	 glob1(Char *, glob_t *, size_t *);
 static int	 glob2(Char *, Char *, Char *, Char *, glob_t *,
@@ -164,6 +167,7 @@
 static int	 globextend(const Char *, glob_t *, size_t *);
 static const Char *globtilde(const Char *, Char *, size_t, glob_t *);
-static int	 globexp1(const Char *, glob_t *);
-static int	 globexp2(const Char *, const Char *, glob_t *, int *);
+static int	 globexp1(const Char *, glob_t *, size_t *);
+static int	 globexp2(const Char *, const Char *, glob_t *, int *,
+    size_t *);
 static int	 match(Char *, Char *, Char *);
 #ifdef DEBUG
@@ -178,4 +182,6 @@
 	int c;
 	Char *bufnext, *bufend, patbuf[MAXPATHLEN+1];
+	/* 0 = malloc(), 1 = stat(), 2 = readdir() */
+	size_t limit[] = { 0, 0, 0 };
 
 	_DIAGASSERT(pattern != NULL);
@@ -213,7 +219,7 @@
 
 	if (flags & GLOB_BRACE)
-	    return globexp1(patbuf, pglob);
+	    return globexp1(patbuf, pglob, limit);
 	else
-	    return glob0(patbuf, pglob);
+	    return glob0(patbuf, pglob, limit);
 }
 
@@ -224,5 +230,5 @@
  */
 static int
-globexp1(const Char *pattern, glob_t *pglob)
+globexp1(const Char *pattern, glob_t *pglob, size_t *limit)
 {
 	const Char* ptr = pattern;
@@ -234,11 +240,11 @@
 	/* Protect a single {}, for find(1), like csh */
 	if (pattern[0] == LBRACE && pattern[1] == RBRACE && pattern[2] == EOS)
-		return glob0(pattern, pglob);
+		return glob0(pattern, pglob, limit);
 
 	while ((ptr = (const Char *) g_strchr(ptr, LBRACE)) != NULL)
-		if (!globexp2(ptr, pattern, pglob, &rv))
+		if (!globexp2(ptr, pattern, pglob, &rv, limit))
 			return rv;
 
-	return glob0(pattern, pglob);
+	return glob0(pattern, pglob, limit);
 }
 
@@ -250,5 +256,6 @@
  */
 static int
-globexp2(const Char *ptr, const Char *pattern, glob_t *pglob, int *rv)
+globexp2(const Char *ptr, const Char *pattern, glob_t *pglob, int *rv,
+    size_t *limit)
 {
 	int     i;
@@ -295,5 +302,5 @@
 		 * unbalanced braces are passed to the match
 		 */
-		*rv = glob0(pattern, pglob);
+		*rv = glob0(pattern, pglob, limit);
 		return 0;
 	}
@@ -342,5 +349,5 @@
 				qprintf("globexp2:", patbuf);
 #endif
-				*rv = globexp1(patbuf, pglob);
+				*rv = globexp1(patbuf, pglob, limit);
 
 				/* move after the comma, to the next string */
@@ -455,5 +462,5 @@
  */
 static int
-glob0(const Char *pattern, glob_t *pglob)
+glob0(const Char *pattern, glob_t *pglob, size_t *limit)
 {
 	const Char *qpatnext;
@@ -461,5 +468,4 @@
 	__gl_size_t oldpathc;
 	Char *bufnext, patbuf[MAXPATHLEN+1];
-	size_t limit = 0;
 
 	_DIAGASSERT(pattern != NULL);
@@ -524,5 +530,5 @@
 #endif
 
-	if ((error = glob1(patbuf, pglob, &limit)) != 0)
+	if ((error = glob1(patbuf, pglob, limit)) != 0)
 		return error;
 
@@ -538,5 +544,5 @@
 		    ((pglob->gl_flags & (GLOB_NOMAGIC|GLOB_MAGCHAR))
 		     == GLOB_NOMAGIC)) {
-			return globextend(pattern, pglob, &limit);
+			return globextend(pattern, pglob, limit);
 		} else {
 			return GLOB_NOMATCH;
@@ -611,4 +617,11 @@
 				return 0;
 		
+			if ((pglob->gl_flags & GLOB_LIMIT) &&
+			    limit[GLOB_INDEX_STAT]++ >= GLOB_LIMIT_STAT) {
+				errno = 0;
+				*pathend++ = SEP;
+				*pathend = EOS;
+				return GLOB_NOSPACE;
+			}
 			if (((pglob->gl_flags & GLOB_MARK) &&
 			    pathend[-1] != SEP) && (S_ISDIR(sb.st_mode) ||
@@ -726,4 +739,12 @@
 		u_char *sc;
 		Char *dc;
+
+		if ((pglob->gl_flags & GLOB_LIMIT) &&
+		    limit[GLOB_INDEX_READDIR]++ >= GLOB_LIMIT_READDIR) {
+			errno = 0;
+			*pathend++ = SEP;
+			*pathend = EOS;
+			return GLOB_NOSPACE;
+		}
 
 		/*
@@ -773,5 +794,6 @@
 			continue;
 		}
-		error = glob2(pathbuf, --dc, pathlim, restpattern, pglob, limit);
+		error = glob2(pathbuf, --dc, pathlim, restpattern, pglob,
+		    limit);
 		if (error)
 			break;
@@ -835,5 +857,5 @@
 		continue;
 	len = (size_t)(p - path);
-	*limit += len;
+	limit[GLOB_INDEX_MALLOC] += len;
 	if ((copy = malloc(len)) != NULL) {
 		if (g_Ctoc(path, copy, len)) {
@@ -845,5 +867,6 @@
 	pathv[pglob->gl_offs + pglob->gl_pathc] = NULL;
 
-	if ((pglob->gl_flags & GLOB_LIMIT) && (newsize + *limit) >= ARG_MAX) {
+	if ((pglob->gl_flags & GLOB_LIMIT) &&
+	    (newsize + limit[GLOB_INDEX_MALLOC]) >= GLOB_LIMIT_MALLOC) {
 		errno = 0;
 		return GLOB_NOSPACE;
Index: /trunk/src/lib/libc/gen/infinityl_ieee754.c
===================================================================
--- /trunk/src/lib/libc/gen/infinityl_ieee754.c	(revision 152)
+++ /trunk/src/lib/libc/gen/infinityl_ieee754.c	(revision 152)
@@ -0,0 +1,39 @@
+/*	$NetBSD: infinityl_ieee754.c,v 1.1.4.2 2011/04/29 07:48:34 matt Exp $	*/
+
+/*
+ * IEEE-compatible infinityl.c for 64-bit or 128-bit long double format.
+ * This is public domain.
+ */
+
+#include <sys/cdefs.h>
+#if defined(LIBC_SCCS) && !defined(lint)
+__RCSID("$NetBSD: infinityl_ieee754.c,v 1.1.4.2 2011/04/29 07:48:34 matt Exp $");
+#endif /* LIBC_SCCS and not lint */
+
+#include <math.h>
+#include <machine/endian.h>
+#include <machine/ieee.h>
+
+#ifdef __HAVE_LONG_DOUBLE
+#define	LDBL_EXPBITS		EXT_EXPBITS
+#define	LDBL_EXP_INFNAN		EXT_EXP_INFNAN
+#else
+#define	LDBL_EXPBITS		DBL_EXPBITS
+#define	LDBL_EXP_INFNAN		DBL_EXP_INFNAN
+#endif
+
+#define	EXP_INFNAN		(LDBL_EXP_INFNAN << (31 - LDBL_EXPBITS))
+
+const union __long_double_u __infinityl = { {
+#if BYTE_ORDER == BIG_ENDIAN
+	[0] = (EXP_INFNAN >> 24) & 0x7f,
+	[1] = (EXP_INFNAN >> 16) & 0xff,
+	[2] = (EXP_INFNAN >>  8) & 0xff,
+	[3] = (EXP_INFNAN >>  0) & 0xff,
+#else
+	[sizeof(long double)-4] = (EXP_INFNAN >>  0) & 0xff,
+	[sizeof(long double)-3] = (EXP_INFNAN >>  8) & 0xff,
+	[sizeof(long double)-2] = (EXP_INFNAN >> 16) & 0xff,
+	[sizeof(long double)-1] = (EXP_INFNAN >> 24) & 0x7f,
+#endif
+} };
